
//-----------------------------------------------------------------------------
// TITULO:      CASTLE OF DR MALVADO
// AUTOR:       DANIEL NAVARRO
// FECHA:       01/02/97
//-----------------------------------------------------------------------------

Program castle_of_dr_malvado;

Global   
    nivel=1;         // Numero de niveles
    vidas=3;         // Numero de vidas
    puntos=0;        // Variable para la puntuacion
    bonos=0;         // Numero de bonos recogidos
    fuente1,fuente2; // Identificadores de las fuentes

    s_pez;           // Identificador para el sonido de los peces
    s_toque;         // Identificador para el sonido de los toques
    s_estrella;      // Identificador para el sonido de estrellas
    s_arania;         // Identificador para el sonido de las aranias
    s_oso;           // Identificador para el sonido de los osos
    s_abeja;         // Identificador para el sonido de abejorro
    s_fantasma;      // Identificador para el sonido de fantasma
    s_salto2;        // Identificador para el segundo sonido de salto
    s_caida;         // Identificador para el sonido de cada
    s_burbuja;       // Identificador para el sonido de las burbujas
    s_bonos;         // Identificador para el sonido de recogida de bonos
    s_malvado;       // Identificador para cuando muere el Doctor malvado

    music, music_menu,music1,music2,music3;

    energia_enemigo;    // Variable para el nivel de energa enemigos fin de fase
    id_barra_enemigo;   // Identificador para quitar la barra de energa
    fin_nivel=false;    // Variable para controlar si se ha terminado un nivel
    idtextovida;        // Variables que manejan el texto cuando sale una vida
    contadortextovida;
    contextovida=0;
    idprincipal;
Local
    velocidad_gravedad; // Variable para guardar la velocidad de cada (gravedad)
    velocidad=0;        // Variable para guardar la velocidad horizontal del protagonista
    muerte;             // Variable para guardar si el protagonista esta muerto
    angulo2;            // Variable de uso general angulos.
// IMPORT "ss1.dll";
Private
    pantalla=1;         // Pantalla que se ve como men
    saliendo=0;         // 1= Se quiere salir del juego
Begin
    idprincipal=id;
    set_mode(320,240,MODE_8BITS);
    set_fps(23,0);      // Velocidad 24 pantallas por segundo
                        //  con un mximo de saltos de 4 pantallas
    // Carga el fichero de grficos general
    load_fpg("malvado.fpg");
    put_screen(0,1);      // Pon la pantalla de fondo
    load_pal("malvado.fpg");    // Carga la paleta de colores
    fade_on();

    // Carga los ficheros de fuentes de las letras
    fuente1=load_fnt("numero.fnt");
    write(fuente1,10,180,3,"Loading...");    
    Frame(500);
    fuente2=load_fnt("letras.fnt");

    // Carga sonidos
    s_pez=load_wav("pez.wav");       // Sonido de peces
    s_toque=load_wav("golpe.wav");      // Sonido de toque
    s_estrella=load_wav("estrella.wav");  // Sonido de estrellas
    s_arania=load_wav("aracnido.wav");   // Sonido de la arania
    s_oso=load_wav("oso.wav");       // Sonido del oso
    s_abeja=load_wav("abeja.wav");    // Sonido del abejorro
    s_fantasma=load_wav("fantasma.wav"); // Sonido del fantasma
    s_salto2=load_wav("salto2.wav");   // Sonido de salto dos
    s_caida=load_wav("caida.wav");     // Sonido de cada
    s_burbuja=load_wav("burbuja.wav");    // Sonido de burbujas
    s_bonos=load_wav("bonus.wav");    // Sonido de bonos
    s_malvado=load_wav("malvado.wav");    // Sonido de muerte de malvado
    music_menu=load_song("music0.mod");
    music=-1; music1=0; music2=0; music3=0;
    fade_off();                     // Apaga la pantalla
    delete_text(all_text);          // Borra todos los textos de pantalla    
    Loop                    // Bucle principal
        play_song(music_menu,-1);
        timer=1000;         // Se inicializa fuera de tiempo para cambiar nada mas entrar
        pantalla=3;         // Elige la otra pantalla porque cambia nada mas entrar
        Repeat                              // Bucle de pantallas de presentacion
	    let_me_alone();
            If (timer>500)                  // Si pasa 5 segundos cambia de pantalla
                timer=0;
                If (pantalla==1)
                    pantalla=3;             //  3:Pantalla crditos
                Else
                    pantalla=1;
                End                         //  1:Pantalla de men
                fade_off();
                put_screen(0,pantalla);
                fade_on();
            End
            angle+=10000;
            Frame;
	    If (key(_space)); exit(0); End;
        Until (key(_enter));
        // Espera a que se pulse una tecla

        // Si has pulsado ESCAPE sal directamente del programa
        If (key(_space));
            fade_off();
            exit("Gracias por jugar!",0);
        End

        fade_off();                     // Apaga pantalla
        // Inicializa variables de juego
        // Fase=1, vidas=3, puntuacion=0, bonus=0
        nivel=1;
        vidas=3;
        puntos=0;
        bonos=0;

        Repeat              // Bucle para pantalla de espera de carga
	    let_me_alone();
	    stop_scroll(0);
	    stop_scroll(1);
	    stop_scroll(2);
	    stop_scroll(3);
            fade_on();      // Enciende la pantalla
            put_screen(0,2);// Pinta pantalla de fondo
            write(fuente2,138,77,4,"NIVEL");
            write_int(fuente2,208,77,4,&nivel);               
            While (fading)  // Espera mientras inicia todo, que
                Frame;      // que ser al acabar el apagado de pantalla
            End
            delete_text(all_text); 	   
	    // Coloca marcadores de puntos, vidas y bonos
            objeto(0,222,16,16,-512,0);     // Pinta vidas
            write(fuente1,36,16,4,"x");
            write_int(fuente1,44,16,3,&vidas);
            write_int(fuente1,160,16,4,&puntos);  // Pinta puntuacion
            objeto(0,216,270,17,-512,0);    // Pinta bonos
            write(fuente1,288,16,4,"x");
            write_int(fuente1,296,16,3,&bonos);  // Inicializa variable  
            fin_nivel=false;                     // controladora de fin de fase                             
                // Pone textos al iniciar un nivel   
            Switch (nivel)  // Bucle para niveles
                    Case 1:         // Inicializa nivel uno
                    // Carga el bloque de grficos del nivel uno
		    stop_song();
                    load_fpg("nivel1.fpg");   
		    If (music1!=music)
		        unload_song(music); music2=0; music3=0;
		    	music=load_song("music1.mod");
			music1=music;
		    End		    	    
		    play_song(music,-1);
                    // Inicializa scroll
                    start_scroll(0,1,1,3,0,4);
                    // Define la zona del scroll a partir de la cual se mueve
                    scroll.region1=define_region(1,96,100,1,1);


                    // Inicializa objetos que tapan otros objetos
                    objeto(1,20,2080,122,-256,1); // Grficos para marcos de puertas
                    objeto(1,21,2102,34,-256,1);
                    objeto(1,22,3286,72,32,1);    // Grfico para tapar burbujas (caldero)

                    // Inicializa objetos de primer plano
                    primer_plano(12,200);        // Planta de junco
                    primer_plano(10,500);        // Seal de direccion a castillo
                    primer_plano(11,780);        // Tumba
                    primer_plano(12,1300);       // Planta de junco
                    primer_plano(13,2150);       // Vela
                    primer_plano(13,2800);       // Vela

                    // Inicializa objetos de cadenas de plataformas
                    cadena(2840,8,0,pi/48,pi/4);
                    cadena(3133,8,pi,pi/32,pi/4);
                    cadena(3660,80,0,pi/24,pi/4);

                    // Inicializa el objeto del protagonista
                    jack(8,0);

                    // Inicializa objetos osos
                    oso(82,189,-1);
                    oso(256,274,-2);
                    oso(484,158,-3);
                    oso(580,247,-2);
                    oso(798,189,-3);
                    oso(1053,191,-3);
                    oso(1675,100,-4);
                    oso(2036,175,-6);

                    // Inicializa objetos abejorro
                    voladores(310,0,600,140,110,64,100,64);
                    voladores(310,0,900,140,110,64,160,100);
                    voladores(310,0,1300,170,90,48,200,50);
                    voladores(310,0,1320,150,95,60,150,75);
                    voladores(310,0,1820,100,48,36,64,64);

                    // Inicializa objetos fantasma
                    voladores(320,4,2170,100,48,36,64,64);
                    voladores(320,4,2329,224,100,24,220,32);
                    voladores(320,4,2865,100,48,36,96,96);
                    voladores(320,4,3100,64,100,36,96,96);

                    // Inicializa objetos arania
                    arania(2349,63,65);
                    arania(2218,152,78);
                    arania(2534,0,77);

                    // Inicializa objetos fuego
                    fuego(2280,256,10);
                    fuego(2390,256,11);

                    // Coge puntos de control del mapa para bonos
                    From z=0 To 25;
                        get_point(1,1,z,&x,&y); // Coge punto
                        bono(x,y);              // Pon bonos    
                End
                End
                               
                Case 2:         // Inicializa nivel dos
                               // Carga fichero de grficos para nivel dos
		         stop_song();
                load_fpg("nivel2.fpg");
		    If (music2!=music)
		        unload_song(music); music1=0; music3=0;
		    	music=load_song("music2.mod"); 
			music2=music;
		    End;
		    play_song(music,-1);

                    // Inicializa scroll para nivel 2
                    start_scroll(0,1,1,3,0,4);
                    // Selecciona la zona del scroll a partir de donde se mueve
                    scroll.region1=define_region(1,160,150,1,1);

                    // Inicializa plataformas metlicas que van en diagonal
                    plataforma_metal(214,1590,128,1443,2);
                    plataforma_metal(108,1249,212,1249,1);
                    plataforma_metal(212,1193,212,1056-58,2);
                    plataforma_metal(108,1193,108,1056+64,1);
                    plataforma_metal(158,582,158,624,5);

                    // Inicializa bola de pinchos
                    bola_pin(157,1121);
                    cadena(160,532,0,pi/24,pi/10);  // Inicializa cadena

                    // Inicializa protagonista
                    jack(8,1971);

                    // Inicializa calabazas
                    calabaza(100,1855,2);
                    calabaza(100,1583,2);
                    calabaza(233,1311,1);
                    calabaza(219,313,2);
                    calabaza(208,189,3);

                    // Inicializa cabezas que escupen
                    cabeza(264,1894,1,24);
                    cabeza(264,1515,1,96);
                    cabeza(264,465,1,26);
                    cabeza(56,1515,0,96);
                    cabeza(56,1298,0,26);
                    cabeza(264,792,1,26);
                    cabeza(56,174,0,24);

                    // Inicializa aranias
                    arania(74,1612,100);
                    arania(245,955,274);
                    arania(75,285,83);
                    arania(245,23,71);

                    // Inicializa fantasmas
                    voladores(320,4,158,1760,90,70,80,80);
                    voladores(320,4,158,1145,140,110,80,80);
                    voladores(320,4,158,616,48,64,80,120);
                    voladores(320,4,158,190,64,96,90,110);

                    // Coge puntos de control para bonos
                    From z=0 To 25;
                        get_point(1,1,z,&x,&y); // Coge puntos
                        bono(x,y);              // Pone bonos
                    End
                End

                Case 3:         // Inicializa fase tres
                    // Carga fichero de grficos para fase tres
		    stop_song();
                    load_fpg("nivel3.fpg");
		    If (music3!=music)
		        unload_song(music); music1=0; music2=0;
		    	music=load_song("music3.mod");
			music3=music;   
		    End;
		    play_song(music,-1);

                    // Inicializa scroll para fase tres
                    start_scroll(0,1,1,3,0,4);
                    // Define la zona de scroll a partir de donde se mueve
                    scroll.region1=define_region(1,160,100,1,1);

                    // Inicializa protagonista
                    jack(64,0);

                    // Inicializa monstruo fin de fase (doctor malvado)
                    malvado();              // Objeto monstruo
                    energia_enemigo=16;     // Cantidad de energa
                    // Identificador necesario por si pasas con truco
                    id_barra_enemigo=barra_energia(); // Inicializa barra de energa
                End

            End

            fade_off();             // Apaga pantalla
            clear_screen();         // Borra pantalla
            fade_on();              // Enciende pantalla

            Repeat                  // Bucle principal del juego
                If (nivel==1)
                    // Crea peces y burbujas decorativos
                    Switch (rand(0,24))
                        Case 0: pez(rand(380,700),292); End
                        Case 1: pez(rand(1290,1354),288); End
                        Case 2: pez(rand(1848,1948),250); End
                        Case 3,4: burbuja(rand(3270,3300),70); End
                    End
                End
                // Si se pulsa a la vez todas las letras que forman la
                // palabra div se pasa de fase
                If (key(_up) AND key (_control) AND key(_enter))
                    fin_nivel=true;
                End
                Frame;
            // Repite hasta que se pase de nivel o te quedes sin vidas
            Until (fin_nivel OR vidas<0 OR key (_space))
            If (key(_space))
                saliendo=1;
            End
            If (fin_nivel)        // Si se ha terminado la fase
                nivel++;          // Incrementa la fase
                fin_nivel=false;  // Inicializa la variable de control de fase
            End
            If (vidas<0)
                write(fuente2,160,100,4,"GAME OVER");
            End
            If (nivel==4)
                write(fuente2,160,100,4,"BIEN HECHO");
            End

            Frame(2400);             // Espera un segundo
            fade_off();              // Apaga pantalla
            stop_scroll(0);          // Para scroll
            // Termina procesos de objetos que tapan grficos
            signal(Type objeto,s_kill);
            // Termina procesos de objetos de primer plano
            signal(Type primer_plano,s_kill);
            // Para todos los sonidos
//            stop_sound(all_sound);
            // Borra todos los textos que haya
            delete_text(all_text);
            // Descarga fichero de grficos
            unload_fpg(1);
            // Quita la barra de energa del enemigo final
            signal(id_barra_enemigo,s_kill);
        // Repite hasta que no tengas vidas o llegue a la fase cuatro
        Until (vidas<0 OR nivel==4 OR key (_space) OR saliendo)
        saliendo=0;
    End
End

//-----------------------------------------------------------------------------
// Proceso para el protagonista
// Entradas: coordenadas horizontal (x) y vertical (y)
//-----------------------------------------------------------------------------    

Process jack(x,y);

Private
    incx=0;     // Variable para comprobar paredes
    ultima_y=0; // Variable para mirar si sube
    ultima_veloc=0;        // Variable para comprobar paredes
    id2;        // Identificador de uso general

Begin
    ctype=c_scroll;             // Mete dentro del scroll
    scroll.camera=id;           // Hace que le siga la cmara
    graph=100;
    priority=1;

    Loop
        // Lee el teclado y el joystick
        If ((key(_right) OR joy.right) AND velocidad<8)
            velocidad+=2;           // Sube velocidad a la derecha
          //  flags=0;                // Mira a la derecha
        Else
            If ((key(_left) OR joy.left) AND velocidad>-8)
                velocidad-=2;       // Sube velocidad a la izquierda
              //  flags=1;            // Mira a la izquierda
            Else                    // Si no hay nada pulsado
                If (velocidad>0)    // Frena a la derecha
                    velocidad-=2;
                End
                If (velocidad<0)    // O frena a la izquierda
                    velocidad+=2;
                End
            End
        End                                                                              

        // Mira si el protagonista choca con las paredes
        ultima_veloc=velocidad;                // Guarda la velocidad en 'ultima_veloc'
        If (ultima_veloc<>0)                   // Y si se mueve
            incx=ultima_veloc/abs(ultima_veloc);          // Halla la direccion
            While (ultima_veloc<>0)            // 'ultima_veloc' sirve de contador
                // Comprueba que no de por debajo
                If (map_get_pixel(1,2,(x+incx)/2,(y-2)/2)<>120)
                    // Ni que de por encima
                    If (map_get_pixel(1,2,(x+incx)/2,(y-32)/2)<>120)
                        x+=incx;    // Y si no da, mueve al mueco
                    End
                End
                ultima_veloc-=incx;            // Resta 'ultima_veloc' hasta que sea cero
            End
        End

        // Si choca con una plataforma crea un nuevo protagonista
        If (id2=collision(Type plataforma))
            // Tiene que estar bajando y por encima de la plataforma
            If (velocidad_gravedad>0 AND abs(x-id2.x)<50 AND y<=id2.y+24)
                jack_plataforma(x-id2.x,id2,50,8);
            End
        End

        // Si choca con una plataforma de metal crea un protagonista nuevo
        If (id2=collision(Type plataforma_metal))
            // Tiene que estar bajando y por encima de la plataforma
            If (velocidad_gravedad>0 AND abs(x-id2.x)<36 AND y<=id2.y+12)
                jack_plataforma(x-id2.x,id2,36,-7);
            End
        End

        gravedad();             // Funcion para hallar la gravedad del protagonista

        If (en_pantalla())      // Si el protagonista no baja
            If (velocidad<>0)   // Y se mueve
                graph++;        // Cambia de grfico paranianimarlo
                If (graph>106)
                    graph=100;
                End
            Else
                graph=101;      // Si no se mueve ponen el grfico por defecto
            End
            // Lee que las teclas (Espacio y Control) o el joystick
            If (key(_space) OR key(_control) OR joy.button1)
                play_wav(s_salto2,0);       // Si esta pulsado haz sonido
                velocidad_gravedad=-12;        // y salta
            End
        Else                    // Si el protagonista si baja
            graph=108;          // Pon el grfico de bajar
        End

        If (ultima_y<y)            // Comprueba si esta bajando
            muerte=true;        // Si baja puede matar
        Else
            muerte=false;       // Si sube o esta quieto le pueden matan
        End

        // Comprueba colision con osos
        If (id2=collision(Type oso))
            puntos+=350;
        Else
            // Comprueba colision con abejas y fantasmas
            If (id2=collision(Type voladores))
                puntos+=575;
            Else
                // Comprueba colision con aranias
                If (id2=collision(Type arania))
                    puntos+=825;
                Else
                    // Comprueba colision con cabezas de monstruo
                    If (id2=collision(Type cabeza))
                        puntos+=150;
                    Else
                        // Comprueba colision con calabazas
                        If (id2=collision(Type calabaza))
                            puntos+=425;
                        End
                    End
                End
            End
        End

        If (id2)        // Comprueba si ha habido cualquier tipo de colision
            If (muerte)     // Y si esta bajando y puede matar
                velocidad_gravedad=-12;     // Hace botar al protagonista
                estrellas(id2.x,id2.y);     // Crea estrellas vistosas
                signal(id2,s_kill);         // Elimina al monstruo que ha originado la colision
                play_wav(s_burbuja,0);   // Y hace ruido de pompas
            Else       // Si no puede matar, entonces el protagonista
                muerte_jack();              // Esta muerto
            End
        End

        // Si es fuego, directamente mata al protagonista
        If (collision(Type fuego)) muerte_jack(); End

        // Si son bolas, directamente mata al protagonista
        If (collision(Type bola)) muerte_jack(); End

        // Si es disparo de las cabezas, directamente mata al protagonista
        If (collision(Type disparo_cabeza)) muerte_jack(); End

        // Si es bola de pinchos, directamente mata al protagonista
        If (collision(Type bola_final)) muerte_jack(); End

        // Comprueba si hay colision con los bonos
        If (id2=collision(Type bono))
            play_wav(s_bonos,0);     // Haz sonido
            bonos++;                    // Incrementa numero de bonos
            puntos+=1000;               // Suma puntos
            estrellas(id2.x,id2.y);     // Crea estrella vistosas
            signal(id2,s_kill);         // Elimina los bonos de pantalla
            If (bonos>=10)              // Y si tiene mas de 10 bonos
                bonos-=10;              // Resta 10 bonos en la cuenta
                vidas++;                // Y suma una vida
                // Pone un mensaje de vida conseguida
                idtextovida=write(fuente1,160,150,4,"VIDA EXTRA");
                contadortextovida=0;
                contextovida=1;
            End
        End

        // Espera cuatro segundos hasta quitar el mensaje
        If (contextovida==1)
            contadortextovida++;
        End
        If (contadortextovida>99 AND contextovida==1)
            delete_text(idtextovida);
            contextovida=2;
        End
        // Actualiza las variables internas del scroll cero
        move_scroll(0);

        If (nivel==1)                   // En el nivel uno
            If (y>300)                  // Si ha pasado el borde inferior
                muerte_jack();          // Mata al protagonista
            End
            If (x>3400)                 // Si ha llegado al extremo derecho
                // Si no ha acabado el nivel y no se ha creado el primer monstruo
                If (NOT fin_nivel AND NOT get_id(Type hijo_malvado_cabeza))
                    hijo_malvado();                     // Crea monstruo fin de fase
                    energia_enemigo=16;                 // Crea barra de energa del monstruo
                    id_barra_enemigo=barra_energia();   // Guarda identificador de la barra de
                                                        // para quitarla si pasas fase con truco
                Else   // Si esta creado el monstruo
                    // Comprueba si el protagonista a chocado
                    If (collision(Type hijo_malvado))
                        muerte_jack();                  // Y si lo toca lo mata
                    End
                End
            End
        Else
            // Si estas en la fase dos y en la posicion final
            If (nivel==2 AND x==58 AND y==53)
                fin_nivel=true;   // Acaba el nivel
            End
        End

        ultima_y=y;   // Guarda y en ultima_y para comprobar luego si baja
        Frame;
    End
End

//------------------------------------------------------------------------------
// Proceso del protagonista cuando esta encima de una
// plataforma para que el protagonista se mueva a la
// vez que la plataforma.
// Entradas: `xrelativa`         Posicion relativa horizontal del
//                               protagonista respecto al centro
//                               de la plataforma
//           `id2`               Identificador de la plataforma
//           `tamanio_plataforma` Tamao (largo) de la plataforma
//           `incy`              Posicion relativa vertical del
//                               protagonista respecto al centro
//                               al centro de la plataforma
//-----------------------------------------------------------------------------

Process jack_plataforma(xrelativa,id2,tamanio_plataforma,incy);

Begin

    // Duerme al proceso padre(El que le ha llamado)
    // mientras esta este proceso activo
    signal(father,s_sleep);
    ctype=c_scroll;     // Hace que este dentro del scroll
    graph=100;          // Pone el grfico apropiado
    flags=father.flags; // Coge las banderas (izq./der.) que tenia el padre
    priority=1;         // Le da prioridad uno para que actualice
                        // antes al protagonista que al scroll
    scroll.camera=id;   // Hace que la cmara le siga

    Loop
        // Lee la tecla de la derecha y el joystick
        If ((key(_right) OR joy.right) AND velocidad<8)
            velocidad+=2;       // Incrementa la velocidad a la derecha
            flags=0;            // Lo pone mirando para la derecha
        Else
            If ((key(_left) OR joy.left) AND velocidad>-8)
                velocidad-=2;       // Incrementa la velocidad a la izquierda
                flags=1;            // Lo pone mirando para la izquierda
            Else                    // Si no se ha pulsado ninguna direccion
                If (velocidad>0)
                    velocidad-=2;    // Frena a la derecha
                End
                If (velocidad<0)
                    velocidad+=2;    // Frena a la izquierda
                End
            End
        End

        xrelativa+=velocidad;          // Suma velocidad a la posicion relativa
        x=xrelativa+id2.x;             // Convierte la posicion relativa en real
        y=id2.y+incy;

        If (velocidad<>0)       // Si el mueco se esta moviendo
           graph++;             // Cambia el grfico paranianimarlo
           If (graph>106)
              graph=100;
           End
        Else
            graph=101;          // Si no pon el grfico de parado
        End

        // Si se pulsa la tecla de salto (espacio o control o joystick)
        If (key(_space) OR key(_control) OR joy.button1)
            signal(father,s_wakeup);                    // Despierta el proceso anterior (el padre)
            father.x=x;                                 // Actualiza coordenada x
            father.y=y;                                 // Actualiza coordenada y
            father.velocidad=velocidad+id2.velocidad;   // Actualiza la velocidad
            father.velocidad_gravedad=-12;              // Hace botar al protagonista
            father.flags=flags;                         // Actualiza banderas (izq./der.)
            play_wav(s_salto2,0);          // Hace sonido de salto dos
            scroll.camera=father;                       // Hace que la cmara le siga
            signal(id,s_kill);                          // Elimina el proceso actual
            Frame;
        End

        // Si el protagonista esta fuera de la plataforma
        If (abs(x-id2.x)>=tamanio_plataforma+4)
            signal(father,s_wakeup);                    // Despierta el proceso anterior
            father.x=x;                                 // Actualiza x
            father.y=y;                                 // Actualiza y
            father.velocidad=velocidad+id2.velocidad;   // Actualiza velocidad
            father.flags=flags;                         // Actualiza banderas (izq./der.)
            father.velocidad_gravedad=0;                // Deja al protagonista suspendido en el aire
            scroll.camera=father;                       // hace que la cmara le siga
            signal(id,s_kill);                          // Elimina el proceso actual
            Frame;
        End

        // Comprueba si ha tocado las abejas o los fantasmas
        If (collision(Type voladores))
            signal(father,s_kill);      // Elimina el proceso anterior
            muerte_jack();              // Mata al protagonista
        End

        // Comprueba si ha tocado con el primer monstruo
        If (collision(Type hijo_malvado))
            signal(father,s_kill);      // Elimina el proceso anterior
            muerte_jack();              // Mata al protagonista
        End

        // Comprueba si ha tocado con el disparo que lanzan las cabezas
        If (collision(Type disparo_cabeza))
            signal(father,s_kill);      // Elimina el proceso anterior
            muerte_jack();              // Mata al protagonista
        End

        // Comprueba si le ha tocado la bola de pinchos
        If (collision(Type bola_final))
            signal(father,s_kill);      // Elimina el proceso anterior
            muerte_jack();              // Mata al protagonista
         End

        // Actualiza las coordenadas internas del scroll
        move_scroll(0);
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para hacer la muerte del mueco
//-----------------------------------------------------------------------------

Process muerte_jack()

Private
    incr_y=-12;                          // Variable para mover grfico poco a poco

Begin
    ctype=c_scroll;                      // Lo mete dentro del scroll
    graph=116;                           // Pone el grfico apropiado
    priority=1;                          // Le da prioridad mxima
    signal(father,s_sleep);              // Duerme al proceso padre (el del protagonista)
    x=father.x;                          // Coge x del protagonista (proceso padre)
    y=father.y;                          // Coge y

    play_wav(s_caida,0);
    // Si esta en el nivel uno
    If (nivel==1)
        scroll.camera=id;                // Hace que la cmara le siga
    End
    y-=12;                               // Mueve el grfico hacia abajo

    Repeat
        y+=incr_y;                           // Sigue bajando el grfico
        incr_y++;                            // Cada vez mas despacio
        angle+=pi/16;                    // A la vez se gira
        size+=4;                         // Y se re-escala
        Frame;
    Until (out_region(id,0));              // Mientras o salga de pantalla
    // Apaga pantalla si le quedan vidas
    If (vidas>0)
        fade_off();
    Else
        idprincipal.x=father.x;
        idprincipal.y=father.y;
        scroll.camera=idprincipal;
    End
    vidas--;
    If (vidas>-1)                       // Si no quedan vidas
        Switch (nivel)                  // Dependiendo de la fase
            Case 1:

                Switch(father.x)         // Y donde se haya quedado
                    Case 0..799:         // crea un nuevo protagonista
                        jack(8,0);       // en la posicion adecuada
                    End
                    Case 800..1959:
                        jack(800,0);
                    End
                    Case 1960..2531:
                        jack(1960,0);
                    End
                    Case 2532..3283:
                        jack(2532,0);
                    End
                    Default:
                        jack(3284,0);
                    End
                End
            End
            Case 2:
                Switch(father.y)
                    Case 0..390:
                        jack(203,422);
                    End
                    Case 391..950:
                        jack(68,921);
                    End
                    Case 951..1400:
                        jack(72,1392);
                    End
                    Case 1401..2000:
                        jack(8,1971);
                    End
                End
            End
        End
        signal(father,s_kill);          // Elimina el protagonista anterior
        //enciende pantalla
        fade_on();
    Else
        signal(Type barra_energia,s_kill_tree); // Elimina la barra de final de
    End                                         // fase si hace falta.

End

//-----------------------------------------------------------------------------
// Proceso para la muerte del mueco especial para la pantalla
// del monstruo final con las bombas
//-----------------------------------------------------------------------------

Process muerte_jack2();

Private
    id2;                      // Identificador para protagonista anterior
    incr_y=-12;               // Variable para bajar grfico poco a poco


Begin

    ctype=c_scroll;           // Integra el grfico en el scroll
    graph=116;                // Coge el grfico de muerto
    id2=get_id(Type jack);    // Coge identificador de protagonista
    signal(id2,s_sleep);      // Y durmelo.
    x=id2.x;                  // Coge la x del protagonista
    y=id2.y-12;               // Coge la y pero un poco mas abajo

    Repeat
        y+=incr_y;                // Mueve grfico hacia abajo
        incr_y++;                 // Cada vez mas lento
        angle+=pi/16;         // Rotacion del grfico
        size+=4;              // Y re-escalado
        Frame;
    Until (out_region(id,0))    // Hasta que se salga de pantalla
    // Apaga pantalla si le quedan vidas
    If (vidas>0)
        fade_off();
    Else
        idprincipal.x=father.x;
        idprincipal.y=father.y;
        scroll.camera=idprincipal;
    End
    vidas--;                  // Quita una vida
    If (vidas>-1)             // Y si todava tienes vidas
        fade_on();            // Encienda la pantalla
        jack(320,0);          // Crea un nuevo protagonista
        signal(id2,s_kill);   // Y elimina el anterior
    Else
        signal(Type barra_energia,s_kill_tree); // Si se acaba el juego
    End                                         // quita la barra del enemigo final
End

//-----------------------------------------------------------------------------
// Proceso para calcular los suelos y la gravedad de mueco
//-----------------------------------------------------------------------------

Process gravedad();

Private
    vgravedad;        // Variable para guardar temporalmente la gravedad

Begin
    // Coge la coordenada y a partir de la gravedad del protagonista (padre)
    vgravedad=(father.velocidad_gravedad++);   // Pero incrementada en 2
    If (vgravedad>12)                           // Si es mayor de 16
        father.velocidad_gravedad=12;           // Haz que sea 16 la gravedad del protagonista
        vgravedad=12;                           // Y tambin la variable temporal
    End

    If (vgravedad<0)                        // Si la gravedad es negativa
        While (vgravedad++!=0)              // Mientras no sea cero, la incrementa
            // Si no se da con el techo
            If (map_get_pixel(1,2,father.x/2,(father.y-24)/3)<>252)
                father.y--;                 // Haz que el protagonista suba
            Else                            // Si no pon la gravedad a cero
                father.velocidad_gravedad=0;
                Break;
            End
        End
    Else                                    // Si la gravedad es cero o positiva
        father.y+=vgravedad;                // Se suma a la coordenada del protagonista
        // Comprueba el rango vertical del movimiento del protagonista
        From vgravedad=-16 To 7 Step 2;     // Acaba el proceso si se toca el suelo
            If (map_get_pixel(1,2,father.x/2,(father.y+vgravedad)/2)==136)
                Break;                      // Sal si se encuentra con el suelo
            End
        End
        If (vgravedad<8)                    // Si se encuentra con el suelo
            father.y+=vgravedad;            // Se actualiza con el mximo que se pueda mover
            father.velocidad_gravedad=0;    // Y se pone la gravedad a 0
        End
    End

End

//-----------------------------------------------------------------------------
// Proceso para comprobar si se toca suelo
// Salidas: True/False, segn si se toca suelo o no
//-----------------------------------------------------------------------------

Process en_pantalla()

Begin

    If (map_get_pixel(1,2,father.x/2,father.y/2)==136)
        Return(true);   // Si se toca suelo el proceso devuelve true
    Else
        Return(false);  // Si no, devuelve false
    End

End

//-----------------------------------------------------------------------------
// Proceso para los objetos de primer plano
// Entradas: 'graph'        numero de grfico
//           'xrelativa'    posicion horizontal relativa (x) del
//                          grfico respecto al scroll
//-----------------------------------------------------------------------------

Process primer_plano(graph,xrelativa);

Begin
    file=1;
    Loop
        y=360-scroll.y0*2;
        x=(xrelativa-scroll.x0)*2;  // Halla la posicion relativa al scroll
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos que tapan otros
// Entradas: 'file'  fichero de grficos que se usa
//           'graph' numero de grfico
//           'x' 'y' Coordenadas 'x' e 'y' del grfico
//           'z'     Profundidad del grfico en pantalla
//           'ctype' Variable para ver si esta dentro del scroll
//-----------------------------------------------------------------------------

Process objeto(file,graph,x,y,z,ctype);

Begin
    Loop
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de los bonos
// Entradas: 'x' 'y' Coordenadas de los objetos
//-----------------------------------------------------------------------------

Process bono(x,y);

Begin
    ctype=c_scroll;         // Haz que este dentro del scroll
    graph=216;              // Pon el grfico inicial del grfico

    Loop                    // Realiza la animacion de los grficos
        graph++;
        If (graph>220)
            graph=216;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de las estrellas
// Entradas: 'x' 'y' Coordenadas de inicio de las estrellas
//-----------------------------------------------------------------------------

Process estrellas(x,y);

Private
    n_estrellas;               // Numero de estrellas (contador)
Begin

    From n_estrellas=0 To 11;            // Crea 12 estrellas iguales
         estrella(x,y);  
    End
End


Process estrella(x,y)
Private
    incr_x;                    // Incremento horizontal
    n_estrellas;               // Numero de estrellas (contador)
Begin
    ctype=c_scroll;            // Haz que este dentro del scroll
    graph=200;                 // Pon el grfico inicial de la estrella
    incr_x=rand(-6,6);                      // Elige al azar el incremento horizontal
    velocidad_gravedad=rand(-24,-8);    // Y tambin el vertical
    n_estrellas=32;

    While (n_estrellas-->0);          // Mientras queden estrellas (n_estrellas = numero de estrellas)
        // Realiza la animacion de los grficos
        graph++;
        If (graph>204) graph=200; End
        x+=incr_x;                      // Mueve las estrellas horizontalmente
        y+=velocidad_gravedad;      // Y verticalmente
        velocidad_gravedad+=2;      // Y reduce el incremento vertical (gravedad)
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de los osos
// Entradas:  'x' 'y' Coordenadas x e y de objeto
//            'incr_x'    Incremento horizontal (a der. e izq.
//-----------------------------------------------------------------------------

Process oso(x,y,incr_x);

Begin
    graph=300;      // Nmero de grfico
    ctype=c_scroll; // Lo mete dentro del scroll
    Loop

        // Haz un sonido de oso de vez en cuando (rand)
        If (rand(0,48)==0) suena_sonido(s_oso,50,256); End
        x+=incr_x;             // Mueve el grfico horizontalmente

        // Si ha llegado al final de la plataforma
        If (NOT en_pantalla())
            incr_x=-incr_x;        // Cambia el incremento horizontal
            x+=incr_x*2;       // Mueve un poco el grfico
            // Da la vuelta al grfico
            If (flags==0)
                flags=1;
            Else
                flags=0;
            End
        End

        // Realiza la animacion de los grficos
        graph++;
            If (graph>304) graph=300; End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos de las calabazas
// Entradas: 'x'        Coordenada x del objeto
//           'ultima_y' Coordenada y del objeto especial
//           'incr_x'       Incremento horizontal (direccion izq/der)
//-----------------------------------------------------------------------------

Process calabaza(x,ultima_y,incr_x);

Private
    anim;                   // Hace que la animacion sea intermitente
    salto=-5;               // Variable para procesar los saltos de la calabaza
    y_temp;                 // Variable temporal de y

Begin
    graph=340;              // Selecciona el grfico inicial
    ctype=c_scroll;         // Introduce el objeto dentro del scroll
    y=ultima_y;             // Carga 'y' con la entrada de proceso ('y' especial)

    Loop
        // Haz sonido del oso de vez en cuando (rand)
        If (rand(0,48)==0) suena_sonido(s_oso,30,512); End
        x+=incr_x;              // Mueve al grfico horizontalmente
        y_temp=y;           // Guarda temporalmente 'y' para comprobar plataformas
        y=ultima_y;            // Y lo carga con la 'y' inicial

        // Si sale fuera de la plataforma donde este
        If (NOT en_pantalla())
            incr_x=-incr_x;         // Cambia la direccion
            x+=incr_x*2;        // Muvelo un poco
        End

        y=y_temp;           // Recupera la 'y' actualizada
        y+=salto;           // Suma a 'y' el salto
        salto++;            // Incrementa 'y' para mover el grfico
        If (salto==6)       // Comprueba si se ha llegado al limite
            salto=-5;       // Para empezar otra vez
        End


        If (anim)           // Comprueba si toca animar al grfico
            graph++;        // Animacion de grficos
            If (graph>344)
                graph=340;
            End
        End

        anim=NOT anim;      // Hace que la animacion sea mas lenta
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para objetos de cabezas que escupen
// Entradas: 'x' 'y'  Coordenadas del grfico
//           'flags'  Direccion hacia donde mira el grfico
//           'pausa'  Numero de frames que esta en pausa
//-----------------------------------------------------------------------------

Process cabeza(x,y,flags,pausa);

Begin
    ctype=c_scroll;                 // Haz que este dentro del scroll
    z=2;                            // Pon al grfico por delante de otros

    Loop
        graph=350;                  // Elige el grfico inicial
        Frame(pausa*100);           // Espera los frames indicados por pausa

        While (graph<355)           // Anmalo hasta que se llegue al limite
            graph++;
            Frame(200);             // Espera dos frames
        End

        // Haz sonido de lanzamiento de gotas horizontales
        suena_sonido(s_toque,20,768);
        // Haz que lance gotas horizontales
        disparo_cabeza(x+20-flags*40,y,4-flags*8,flags);
    End

End

//-----------------------------------------------------------------------------
// Proceso para lanzamiento de gotas horizontales
// Entradas: 'x' 'y' Coordenadas del objeto
//           'incx'  Incremento horizontal (direccion)
//           'flags' Posicion hacia la que mira el grfico
//                   horizontalmente
//-----------------------------------------------------------------------------

Process disparo_cabeza(x,y,incx,flags);

Begin
    ctype=c_scroll;               // Hace que este dentro del scroll
    graph=356;                    // Elige el grfico apropiado

    Repeat
        x+=incx;                  // Muvelo horizontalmente
        Frame;
    Until (out_region(id,0))      // Hasta que salga de pantalla

End

//-----------------------------------------------------------------------------
// Proceso para objetos de los abejorros y fantasmas
// Entradas:  'gr'            Tipo de grfico (abejorro/fantasma)
//            'flags'         Tipo de transparencia
//            'xrelativa'     Posicion x de referencia
//            'yrelativa'     Posicion y de referencia
//            'incx' 'incy'   Frecuencia de giro en los dos ejes
//            'distx' 'disty' Distancia del giro en los ejes
//-----------------------------------------------------------------------------

Process voladores(gr,flags,xrelativa,yrelativa,incx,incy,distx,disty);

Private
    angulo3;
    id2;

Begin
    graph=gr;            // Elige el grfico inicial apropiado
    ctype=c_scroll;      // haz que este dentro del scroll

    Loop
        // Haz un sonido de vez en cuando
        If (rand(0,48)==0)
            // Sonido de fantasmas
            If (flags==4)
                suena_sonido(s_fantasma,50,256);
            // Sonido de abejorros
            Else
                suena_sonido(s_abeja,150,256);
            End
        End

        angulo2+=pi/incx;                 // Halla el tamanio de los incrementos
        angulo3+=pi/incy;                 // que se harn en las dos coordenadas
        x=xrelativa+get_distx(angulo2,distx);    // Incrementa la coordenada x
        y=yrelativa+get_disty(angulo3,disty);    // Incrementa la coordenada y

        // Realiza la animacion de los grficos
        graph++;
        If (graph==gr+6)
            graph=gr;
        End
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para los objetos de tipo burbuja
// Entradas: 'x' 'y' Coordenadas del objeto en pantalla
//-----------------------------------------------------------------------------

Process burbuja(x,y);

Begin
    z=64;                // Pone los grficos un poco detrs
                         // paranias poder taparlos con la olla
    graph=430;           // Elige el grfico apropiado
    ctype=c_scroll;      // Pon el objeto dentro del scroll
    While (size>0)       // Mientras el tamanio(re-escalado) sea mayor que cero
        y-=2;            // Mueve el objeto hacia arriba
        size-=2;         // Y reduce su tamanio.
        Frame;
    End
End

//-----------------------------------------------------------------------------
// Proceso para objetos tipo pez.
// Entradas:  'x'  Coordenada horizontal del grfico
//            'yrelativa' Coordenada vertical especial del grfico
//-----------------------------------------------------------------------------

Process pez(x,yrelativa);

Private
    incr_y;                 // Incremento vertical del grfico

Begin
    z=-10;
    chapuzon(x,yrelativa);  // Pone un chapuzn de agua
    graph=410;              // Coge el grfico inicial del pez
    ctype=c_scroll;         // Pone al objeto dentro del scroll
    y=yrelativa;            // Actualiza y con la entrada del proceso
    incr_y=-12;             // Inicializa el incremento (hacia arriba)
    // Haz sonido para peces
    suena_sonido(s_pez,25,512);

    // Mientras no se llegue al limite de movimiento
    While (incr_y<12)
        // Realiza la animacion del grfico, mientras se este moviendo (incr_y<>0)
        If (incr_y AND graph<416)
            graph++;
        End
        y+=incr_y;          // Mueve al grfico verticalmente
        incr_y++;           // Actualiza el incremento vertical
        Frame;
    End
    chapuzon(x,yrelativa);  // Pone un chapuzn de agua
End

//-----------------------------------------------------------------------------
// Proceso para reproducir sonidos
// Entradas: 'x'          Identificador del sonido
//           'volumen'    Volumen del sonido
//           'frecuencia' Frecuencia del sonido
//-----------------------------------------------------------------------------

Process suena_sonido(x,volumen,frecuencia);

Begin
    // Si el grfico esta dentro de la pantalla realiza el sonido
    If (NOT (out_region(father,0)))
        play_wav(x,0);
    End
End

//------------------------------------------------------------------------------
// Proceso para poner objetos de chapuzn de agua
// Entradas: 'x' 'y' Coordenadas del objeto
//------------------------------------------------------------------------------

Process chapuzon(x,y);

Begin
    ctype=c_scroll;     // Pon el objeto dentro del scroll
    // Realiza la animacion de los grficos
    From graph=400 To 405;
        Frame(200);     // Espera dos frames
    End
End

//-----------------------------------------------------------------------------
// Proceso para poner los objetos arania
// Entradas: 'x' 'y'  Coordenadas del objeto
//           'height' Altura del objeto
//-----------------------------------------------------------------------------

Process arania(x,y,height);

Private
    contador;                             // Contador de uso general

Begin
    z=-11;
    ctype=c_scroll;                // Hace que este dentro del scroll
    graph=330;                     // Elige el grfico inicial
    height=(height/4)*4;           // Hace height mltiplo de cuatro

    Loop
        From contador=0 To 47;
            // Realiza la animacion de la arania de vez en cuando (rand)
            If (rand(0,10)==0)
                graph++;
                If (graph>335) graph=330; End
            End
            Frame;
        End

        // Haz el sonido de la arania
        suena_sonido(s_arania,200,256);
        // Baja el objeto de 4 en 4 con el grfico inmvil
        For (contador=0;contador<height;contador+=4);
            y+=4;
            Frame;
        End

        // Sube el objeto de 1 en 1 con animacion de grficos
        For (contador=0;contador<height;contador++);
            y--;
            ++graph;
            If (graph>335)
                graph=330;
            End
            Frame;
        End
    End
End

//-----------------------------------------------------------------------------
// Proceso para los objetos de las cadenas
// Entradas: 'x' 'y' Coordenadas del objeto
//           'ang'   Angulo inicial del objeto
//           'iang'  Velocidad de incremento dentro del angulo
//           'foco'  Tamao total de angulo (min-max)
//-----------------------------------------------------------------------------

Process cadena(x,y,ang,iang,foco);

Begin
    priority=10;      // Pone un poco menos de prioridad que la plataforma
    ctype=c_scroll;   // Pone el grfico dentro del scroll
    file=1;           // Escoge el fichero de grficos 1
    graph=14;         // Coge el grfico de la cadena
    z=20;             // Pone el grfico por detrs de la plataforma
    plataforma();     // Crea una plataforma

    Loop
        ang+=iang;    // Incrementa el angulo
        // Coge el angulo del coseno para hacer movimiento pendular con distintas velocidades
        angle=get_distx(ang,foco);
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para objetos plataformas
//-----------------------------------------------------------------------------

Process plataforma()

Begin
    priority=9;         // Pone mas prioridad que a la cadena
    ctype=c_scroll;     // Pone el objeto dentro del scroll
    file=1;             // Usa el fichero de grficos 1
    graph=15;           // Coge el grfico de la plataforma
    z=19;               // Pone el grfico por encima de la cadena

    Loop
        // Coge las coordenadas de la plataforma respecto a la cadena
        velocidad=father.x+get_distx(father.angle-pi/2,130)-x;
        x+=velocidad;
        y=father.y+get_disty(father.angle-pi/2,130);
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para objetos de plataformas metlicas
// Entradas: 'x1' 'y1' Coordenadas iniciales de la plataforma
//           'x2' 'y2' Coordenadas finales de la plataforma
//           'ipaso'   Incremento (velocidad) en %
//-----------------------------------------------------------------------------

Process plataforma_metal(x1,y1,x2,y2,ipaso);

Private
    paso;            // Contador de proceso de movimiento (indica por donde va)

Begin
    priority=10;     // Le da una prioridad baja
    ctype=c_scroll;  // Pone el grfico en el scroll
    file=1;          // Elige el fichero de grficos uno
    graph=16;        // Elige el grfico de la plataforma metlica
    x=x1;            // Introduce las coordenadas iniciales
    y=y1;

    Loop
        // Actualiza las nuevas coordenadas
        x=(x1*paso+x2*(100-paso))/100;
        y=(y1*paso+y2*(100-paso))/100;
        // Suma el incremento necesario
        paso+=ipaso;
        // Si se ha llegado al cien por cien
        If (paso MOD 100==0)
            ipaso=-ipaso;              // Cambia la direccion
            suena_sonido(s_estrella,12,512);  // Haz sonido de estrellas
        End
    Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para el objeto del monstruo de la primera fase
//-----------------------------------------------------------------------------

Process hijo_malvado();

Private
    contador;                             // Contador de carcter general
    regionx=96;                    // Necesario para centrar la pantalla

Begin
    file=1;                        // Elige el primer fichero de grficos
    ctype=c_scroll;                // Introduce el grfico dentro del scroll
    x=3800;                        // Coge coordenadas
    y=261;
    z=8;                           // Elige la profundidad (detrs)
    graph=104;                     // Elige el grfico inicial
    hijo_malvado_cabeza();         // Crea la cabeza del monstruo

    // Modifica la region de movimiento de scroll
    // para centrarla, con el mueco, en el centro de la pantalla
    While (regionx<160); // La modifica poco a poco (suavemente)
        define_region(1,++regionx,100,1,1);
        Frame;
    End

    Loop
        graph=104;                  // Elige grfico inicial
        flags=0;                    // Sin ningn tipo de espejo
        Frame(5000);                // Pon el grfico y espera 50 frames (un segundo)
        graph=105;                  // Pone el grfico de lanzando bola
        Frame(400);                 // Imprime y espera 4 frames
        graph=106;                  // Pone el grfico de ya haber lanzado bola
        bola(x-16,y-30,-6);         // Crea bola de fuego
        Frame(400);                 // Espera 4 frames
        graph=105;                  // Pone el grfico como recogindose
        Frame(400);                 // Espera 4 frames
        graph=104;                  // Pone el grfico inicial
        Frame(5000);                // Espera 50 frames
        graph=107;                  // Pone el grfico para saltar
        // Mueve el grfico (salta)
        From contador=-16 To 16;
            y+=contador;
            x-=10;
            Frame;
        End
        // Haz sonido de toque
        play_wav(s_toque,0);
        graph=104;                 // Grfico inicial
        flags=1;                   // Hace espejo para que mire el protagonista
        Frame(5000);               // Repite el proceso de arriba
        graph=105;
        Frame(400);
        graph=106;
        bola(x+16,y-30,6);
        Frame(400);
        graph=105;
        Frame(400);
        graph=104;
        Frame(5000);
        graph=107;
        From contador=-16 To 16;
            y+=contador;
            x+=10;
            Frame;
        End
        // Realizada sonido de toque
        play_wav(s_toque,0);
    End
End

//-----------------------------------------------------------------------------
// Proceso para objeto de cabeza de monstruo primera fase
//-----------------------------------------------------------------------------

Process hijo_malvado_cabeza();

Private
    angulo0;                               // Variable para mover la cabeza en forma de elipse
    id2;                               // Identificador del protagonista y del cuerpo al final (monstruo muerto)
    // Crea una cadena de variables de 50 posiciones para la animacion de los grficos
    anim[]=40 DUP (100),101,101,102,102,103,103,102,102,101,101;
    ianim;                             // Contador dentro de la cadena de animacion
    incy=0;                            // Variable para bajar y subir la cabeza
                                       // cuando el protagonista la toca y quita el cuerpo
                                       // cuando se acaba la fase
Begin
    file=1;                            // Elige el fichero de grficos 1
    graph=100;                         // Pone el grfico inicial
    ctype=c_scroll;                    // Pone el grfico dentro del scroll
    z=4;                               // Profundidad por delante del cuerpo pero detrs del protagonista
    Repeat
        // Pone la cabeza al revs del cuerpo para colocarla
        If (father.flags==1) flags=0; Else flags=1; End
        x=father.x+get_distx(angulo0,6);   // Coge las coordenadas respecto al cuerpo
        y=father.y-70+get_disty(angulo0,4);// pero en con un movimiento tipo elipse
        graph=anim[ianim];             // Coge el grfico necesario para la animacion
        ianim=(ianim+1) MOD 50;        // Incrementa el contador dentro de la cadena de animacion

        // Haz sonido de oso cada 40 animaciones
        If (ianim==40) play_wav(s_oso,0); End
        angulo0+=pi/48;

        // Comprueba si se ha tocado al protagonista
        If (id2=collision(Type jack))
            // Si el protagonista esta mas alto que el monstruo
            // y si el protagonista esta vivo
            If (id2.muerte AND id2.y<=y)
                incy=64;                    // Baja la cabeza del monstruo
                id2.velocidad_gravedad=-26; // Cambia la gravedad
                puntos++;                   // Suma puntuacion
                energia_enemigo--;          // Quita energa al monstruo
                estrellas(x,y);             // Pone estrellas vistosas
                play_wav(s_burbuja,0);   // Realiza sonido de burbuja
            End
        End

        // Sube la cabeza del monstruo si es que esta bajada
        If (incy>0)
            y+=incy/2;
            Frame;
            incy--;
        Else
            Frame;
        End
    Until (energia_enemigo==0)      // Repite mientras el monstruo tenga energa

    // Se crea un cuerpo de monstruo
    id2=objeto(1,104,father.x,father.y,8,1);
    signal(father,s_kill);      // Y elimina el anterior
    incy=-24;                   // Incremento de bajada del cuerpo
    play_wav(s_malvado,0);   // Haz sonido
    Repeat
        id2.y+=(incy/2);             // Mueve el cuerpo
        incy++;                      // Reduce velocidad de cada
        y=id2.y-56;                   // Mueve la cabeza
        If (incy MOD 8==0)           // Crea estrella cada 8 animaciones
            estrellas(x,y);
        End
        Frame;
    Until (y>350);                   //Mientras la cabeza no llegue al suelo

    // Pone la variable a uno para indicar que se ha acabo el nivel
    fin_nivel=true;
End


//-----------------------------------------------------------------------------
// Proceso para el objeto de monstruo final tercera fase
//-----------------------------------------------------------------------------
Process malvado();

Private
    contador;                              // Contador de carcter general
    idcabeza;                       // Identificador para la cabeza del monstruo

Begin
    file=1;                         // Coge el fichero de grficos uno
    ctype=c_scroll;                 // Pone el objeto en  el scroll
    x=552;                          // Inicializa coordenadas del objeto
    y=230;
    z=8;                            // Pone el cuerpo detrs (profundidad) de la cabeza
    idcabeza=malvado_cabeza();      // Crea cabeza del monstruo

    Loop
        graph=200;                 // Pone grfico inicial
        flags=0;                   // Pone mirando al protagonista (por defecto)
        Frame(5000);               // Espera 50 frames (1 segundo aprox.)
        graph=203;                 // Cambia grfico paranianimarlo
        Frame(300);                // Espera 3 frames
        graph=204;                 // Cambia grfico paranianimarlo
        Frame(300);                // Espera 3 frames
        graph=205;                 // Cambia grfico a monstruo tirando bombas
        bomba(x-38,y+24,-6);       // Crea un objeto bomba
        Frame(400);                // Espera 4 frames
        graph=200;                 // Cambia grfico paranianimarlo (inicial)
        Frame(5000);               // Espera 50 frames
        graph=201;                 // Cambia grfico
        idcabeza.graph=101;        // Cambia grfico de la cabeza del monstruo
        From contador=-16 To 16;
            // Si esta en el medio de la animacion
            If (contador==0)
                graph=202;              // Cambia grfico del cuerpo
                idcabeza.graph=102;     // Cambia el grfico de la cabeza
            End
            // Mueve al monstruo (salto)
            y+=contador;
            x-=14;
            Frame;
        End

        idcabeza.graph=100;         // Cambia grfico de la cabeza
        play_wav(s_toque,0);     // Haz sonido de toque
        graph=200;                  // Grfico inicial
        flags=1;                    // Lo pone mirando hacia el mueco
        Frame(5000);                // Repite la animacion de anterior
        graph=203;
        Frame(300);
        graph=204;
        Frame(300);
        graph=205;
        bomba(x+38,y+24,6);         // Crea bomba
        Frame(400);
        graph=200;
        Frame(5000);
        // Vuelve a saltar hacia el otro lado
        graph=201;
        idcabeza.graph=101;
        From contador=-16 To 16;
            If (contador==0)
                graph=202;
                idcabeza.graph=102;
            End
            y+=contador;
            x+=14;
            Frame;
        End

        idcabeza.graph=100;
        // Realiza sonido de toque
        play_wav(s_toque,0);
    End
End


//-----------------------------------------------------------------------------
// Proceso para el objeto de la cabeza del monstruo
//-----------------------------------------------------------------------------


Process malvado_cabeza();

Private
    angulo0;                                 // Para movimiento tipo elipse
    id2;                                     // Identificador para crear un cuerpo nuevo
    incy;                                    // Para bajar la cabeza y quitar el monstruo al final
                                             // si el protagonista lo toca o lo mata
Begin
    file=1;                                  // Elige el fichero de grficos 1
    graph=100;                               // Elige el grfico inicial
    ctype=c_scroll;                          // Pone al objeto dentro del scroll
    z=4;                                     // Pone la cabeza por encima del cuerpo

    Repeat
        flags=father.flags;                      // Coge la posicion (der/izq) del cuerpo
        x=father.x-18+flags*36+get_distx(angulo0,6); // Coge las coordenadas respecto al cuerpo
        y=father.y-32+get_disty(angulo0,4);          // pero con movimiento tipo elipse
        angulo0+=pi/48;                              // Incrementa el movimiento tipo elipse
        Frame;
    Until (energia_enemigo==0)                   // Mientras el monstruo tenga energa

    // Crea un nuevo cuerpo de monstruo
    id2=objeto(1,202,father.x,father.y,8,1);
    // Para eliminar el cuerpo de la cabeza
    signal(father,s_kill);
    incy=-24;                  // Selecciona velocidad de bajada(incremento
    graph=103;                 // Elige un grfico de cabeza muerta
    flags=0;                   // Quita cualquier tipo de efecto espejo
    play_wav(s_malvado,0);  // Haz sonido
    Repeat
        id2.y+=incy/2;         // Mueve el cuerpo (hacia abajo)
        incy++;                // Cada vez mas despacio
        y=id2.y-32;            // Mueve la cabeza hacia abajo
        x=id2.x-18;            // Y a la izquierda
        // Pon estrellas cada ocho animaciones
        If (incy MOD 8==0)
            estrellas(x,y);
        End
        Frame;
    Until (y>350);             // Repite mientras la cabeza no toque el suelo
    fin_nivel=true;            // Indica que se ha acabado el nivel
End

//-----------------------------------------------------------------------------
// Proceso para el objeto las bolas que tira el monstruo fase1
// Entradas: 'x' 'y'  coordenadas del objeto
//           'incr_x'     Incremento de movimiento (izq.der.)
//-----------------------------------------------------------------------------

Process bola(x,y,incr_x);

Begin
    file=1;                             // Elige el fichero de grficos 1
    graph=108;                          // Pon el grfico de bola de fuego
    ctype=c_scroll;                     // Inclyelo dentro del scroll
    z=4;                                // Por delante del cuerpo y la cabeza pero detrs del protagonista
    play_wav(s_toque,0);             // Haz sonido de toque

    Repeat
        x+=incr_x;                          // Mueve el objeto
        graph++;
        // Realiza la animacion de grficos
        If(graph>110) graph=108; End
        Frame;
    Until (x<3000 OR x>4000)           // Repite hasta que se salga de pantalla

End

//-----------------------------------------------------------------------------
// Proceso para las bombas que tira el monstruo final fase 3
// Entradas: 'x' 'y' Coordenadas del objeto
//           'inc'   Incremento horizontal (der/izq)
//-----------------------------------------------------------------------------


Process bomba(x,y,incr_x);

Private
    incr_y;                                 // Posicion vertical de la bomba
    iymax;                              // Posicion mxima vertical de la bomba
    id2;                                // Identificador para hallar colisiones
    toque=false;                        // Variable para comprobar si la bomba la tira el monstruo
                                        // o la tira el protagonista
Begin
    file=1;                             // Elige los grficos de fichero 1
    graph=300;                          // Pon grfico inicial
    ctype=c_scroll;                     // Ponlo dentro del scroll
    z=4;                                // Pon por detrs del protagonista y delante del monstruo
    iymax=rand(-10,-22);                // Altura mxima de la bomba al azar (rand)
    incr_y=iymax;                       // Empieza en la altura mxima
    play_wav(s_toque,0);              // Realiza sonido de toque

    Repeat
        y+=incr_y;                      // Mueve la bomba
        incr_y+=2;
        // Hace que la bomba bote
        If (incr_y>-iymax)
            iymax+=2;
            incr_y=iymax;
            play_wav(s_toque,0);      // Pon sonido de toque
        End
        x+=incr_x;

        // Si la bomba la tira el monstruo
        If (NOT toque)
            // Si la toca el protagonista
            If (id2=collision(Type jack))
                toque=true;
                // Si el protagonista esta vivo
                If (id2.muerte)
                    incr_x=-incr_x;                     // Cambia la direccion de la bomba
                    id2.velocidad_gravedad=-20; // Hace botar al protagonista
                    estrellas(x,y);             // Pone estrellas
                    puntos++;                   // Suma puntos
                    play_wav(s_burbuja,0);    // Pone sonido de pompa
                Else
                    muerte_jack2();             // Si no mata al protagonista
                End
            End
        End

        // La bomba toca al monstruo le quita energa
        If (id2=collision(Type malvado))
            energia_enemigo--;
            Break;
        End

        Frame;
    // Repite el proceso hasta que la bomba salga de pantalla
    Until (x<64 OR x>640-64 OR iymax>=0)

    // Sonido de toque
    play_wav(s_toque,0);
    // Realiza animacion
    From graph=301 To 309;
        Frame(200);                             // Espera dos frames por grfico
    End

End

//-----------------------------------------------------------------------------
// Proceso para el objeto fuego
// Entradas: 'x' 'y' Coordenadas del objeto
//           'inc'   Mximo movimiento que realizara el objeto
//-----------------------------------------------------------------------------

Process fuego(x,y,inc)

Private
    contador;                           // Contador de uso general

Begin
    ctype=c_scroll;                     // Pon el grfico dentro del scroll
    Loop
        graph=0;                        // Elige un grfico nulo
        flags=0;                        // Sin ningn tipo de efecto espejo
        From contador=0 To 23;          // Pon 24 grficos
            Frame;
        End

        graph=420;                      // Elige grfico inicial
        suena_sonido(s_toque,50,128);   // Haz sonido de toque

        For (contador=-inc;contador<=inc;contador++);        // Realiza movimiento hasta el incremento (subida)
            If (graph==420)             // Alterna los grficos
                graph=421;              // Si esta quitado lo pone
            Else                        // Y si esta puesto
                graph=420;              // Lo quita
            End
            If (contador==1)            // Si ha llegado arriba
                flags=2;                // Da la vuelta al grfico (mirando hacia abajo)
            End
            Frame;
            y+=contador;                // Mueve objeto
        End

    End
End

//-----------------------------------------------------------------------------
// Proceso para el objeto de la barra de energa
//-----------------------------------------------------------------------------

Process barra_energia();

Begin
    graph=10;                               // Elige el grfico inicial
    x=160;                                  // Pon coordenadas
    y=240;
    z=-9;                                   // Pon la barra por encima de los grficos

    While (energia_enemigo>0)               // Mientras se tenga energa
        // Sube barra energa desde fuera de la pantalla a su posicion
        If (y>230)
            y--;
        Else
          If (region!=10)                   // Si no tiene region crala
            region=10;
            objeto(0,11,160,230,-10,0);     // Crea detrs el grfico de la barra vaca
          End
        End
        // Define la region respecto al tamanio de la barra de energa
        // y as solo ver la zona que representa a la misma
        define_region(10,120,225,1+energia_enemigo*5,10);
        Frame;
    End

    // Elimina el proceso de la barra que hay detrs (barra vaca)
    signal(son,s_kill);
End

//-----------------------------------------------------------------------------
// Proceso para el objeto de la conexion bola de pinchos
// Entradas: 'x' 'y' Coordenadas del objeto
//-----------------------------------------------------------------------------

Process bola_pin(x,y)

Begin
    file=1;                    // Elige el primer fichero de grficos
    graph=20;                  // Elige el grfico inicial
    ctype=c_scroll;            // Pone el objeto dentro del scroll
    priority=100;              // Pone la prioridad baja para ligar a la cadena
    cadena_bola(id,20);        // Crea cadena de pinchos
    z=-20;                     // Pone por encima de la pantalla

    Loop
        angulo2+=pi/64;        // Mueve la cadena y la bola de pinchos
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para el objeto de cadena de bola de pinchos
// Entradas: 'primero'     Identificador a la conexion
//           'distancia'  Distancia a la conexion
//-----------------------------------------------------------------------------

Process cadena_bola(primero,distancia)

Begin
    file=1;                             // Elige el primer fichero de grficos
    graph=21;                           // Elige el grfico inicial
    ctype=c_scroll;                     // Pone el objeto dentro del scroll
    z=-10;                              // Pone la cadena por detrs de la conexion

    If (distancia<80)                       // Si el tamanio restante es lo suficientemente grande
        cadena_bola(primero,distancia+20);  // Crea otra bola de cadena
    Else
        bola_final(primero,distancia+32);   // Si no crea la bola de pinchos final
    End

    Loop
        angulo2=primero.angulo2;                     // Coge el angulo de la conexion
        x=primero.x+get_distx(angulo2,distancia);    // Halla las coordenadas respecto
        y=primero.y+get_disty(angulo2,distancia);    // a la conexion y al angulo
        Frame;
    End

End

//-----------------------------------------------------------------------------
// Proceso para el objeto de la bola de pinchos final
// Entradas: 'primero'     Identificador a la conexion
//           'distancia'  Distancia a la conexion
//-----------------------------------------------------------------------------

Process bola_final(primero,distancia)

Begin
    file=1;                                      // Elige el fichero de grficos 1
    graph=22;                                    // Pon el grfico inicial
    ctype=c_scroll;                              // Dentro del scroll
    z=-20;                                       // Por delante de la cadena

    Loop
        angulo2=primero.angulo2;                    // Coge el angulo de la conexion
        x=primero.x+get_distx(angulo2,distancia);   // Actualiza coordenadas respecto a
        y=primero.y+get_disty(angulo2,distancia);   // la distancia a la conexion y el angulo
        // Haz sonido de estrellas;
        suena_sonido(s_estrella,10,768);
        Frame;
    End

End
















